// ***************************************************
// Tetris
//
//  Modified for Drupal by Glenn Linde Dec 2008
//  Original javascript by Joan Alba Maldonado (granvino@granvino.com).
//  http://sourceforge.net/projects/tetrissimus/
//  This software is supplied without warranty under the GNU Public licence agreement.
//
// ***************************************************

var isExplorer=navigator.appName.indexOf("Microsoft")!=-1;

//Variable que activa el mapa modo debug:
//var tetris_show_map_debug = false;
var tetris_scale=0.8;
//Variable que guarda el primer evento del keydo, por razones de compatibilidad:
var primer_evento = "";
  
//Se declara la matrix para guardar el mapa:
var map_matrix = new Array();

//El number de columns del mapa:
var tetris_number_columns = 12;
//El number de lines del mapa:
var tetris_number_lines = 22;


//Se realiza un bucle para guardar el mapa en la matrix:
for (x=0; x<tetris_number_columns*tetris_number_lines; x++)
		map_matrix[x]="0";
		
		
//Variable que guarda el number de la piece actual:
var tetris_number_piece = 0;
//Variable que guarda el number de la piece following:
var tetris_number_piece_following = 0;

//matrix que contiene la coleccion de pieces, con su ancho, alto y color:
var tetris_piece = new Array();

//Varialbe para saber si una piece se ha elevado verticalmente al ser rotada:
var al_rotar_se_ha_elevado = false;

//Variable donde se guardara el Interval del movimiento de la piece cayendo:
var movimiento_piece = setInterval("", 1);

//Variable donde se guardara el Timeout que hara que el message del centro de la pantalla se oculte:
var tetris_hide_message = setTimeout("", 1);

//Variable donde se guarda el number de pieces:
var tetris_number_pieces = 0;

//Variable que indica si se ha acabado el game o todavia no:
var tetris_game_over = false; //Todavia no se ha acabado el game.

//Variable que define las lineas necesarias para cambiar de level:
var lineas_necesarias = 6;

//Variable que cuenta cuantas lineas se han realizado en el level actual:
var lineas_level_actual = 0;

//Variable donde se guarda la puntuacion:
var puntuacion = 0;

//Variable donde se guada el level:
var tetris_level = 1;

//Contador de leveles, que cuando llega a 10 se sube el displacement de las pieces (se desplazan mas espcio hacia abajo, para hacerlo mas dificil):
var contador_leveles_displacement = 0;

//Variable que impide el Game Over, cuando ya ha ocurrido:
var prevent_tetris_game_over = false;

//matrix vacia que se utilizara para cuando se llame a tetris_show_map:
var guardar_map_previous = new Array();

var tetris_dragging=false;
var tetris_dragging_start_y=false;
var tetris_height;
var tetris_width;

var tetris_piece1_img="/modules/tetris/img/orange.png";
var tetris_piece2_img="/modules/tetris/img/red.png";
var tetris_piece3_img="/modules/tetris/img/blue.png";
var tetris_piece4_img="/modules/tetris/img/purple.png";
var tetris_piece5_img="/modules/tetris/img/lightblue.png";
var tetris_piece6_img="/modules/tetris/img/green.png";
var tetris_piece7_img="/modules/tetris/img/yellow.png";

var tetris_piece1_color="orange";//"#aaffdd";
var tetris_piece2_color="red";//"#ffffdd";
var tetris_piece3_color="blue";//#ddaaff";
var tetris_piece4_color="purple";//#ffaadd";
var tetris_piece5_color="cyan";//#ffddff";
var tetris_piece6_color="green";//#aaddff";
var tetris_piece7_color="yellow";//#ffddaa";

var tetris_start_message="Left, right arrow to move. Up down arrow to rotate.";
var tetris_game_begins_message="The game begins";
var tetris_gameover_message="Game Over";

var tetris_keyboard=true;
var tetris_mouse=false;

var tetris_leftkey=90;  // Z
var tetris_rightkey=88; // X
var tetris_upkey=('J').charCodeAt(0);
var tetris_downkey=('M').charCodeAt(0);

var tetris_initial_game_speed=1500;
var tetris_speed_increase_per_level=25;
var tetris_background;
var tetris_bestscore;

function is_x(val)
{
	if (val&&val.length>0&&val.substring(0,1)=="X")
		return true;
	else
		return false;
}

//Funcion que crea las pieces, con su ancho, alto y color:
function tetris_create_pieces()
{
	//piece 1:
	tetris_piece[1] = new Array();
	tetris_piece[1]["form"] = "1" +
						"1" +
						"1" +
						"1";
	tetris_piece[1]["width"] = 1;
	tetris_piece[1]["height"] = 4;
	tetris_piece[1]["color"] = tetris_piece1_color;//"#aaffdd";
	tetris_piece[1]["img"] = tetris_piece1_img;//"orange.png";

	//piece 2:
	tetris_piece[2] = new Array();
	tetris_piece[2]["form"] = "22" +
						"22";
	tetris_piece[2]["width"] = 2;
	tetris_piece[2]["height"] = 2;
	tetris_piece[2]["color"] = tetris_piece2_color;//"#ffffdd";
	tetris_piece[2]["img"] = tetris_piece2_img;//"red.png";

	//piece 3:
	tetris_piece[3] = new Array();
	tetris_piece[3]["form"] = "33" +
						"03" +
						"03";
	tetris_piece[3]["width"] = 2;
	tetris_piece[3]["height"] = 3;
	tetris_piece[3]["color"] = tetris_piece3_color;//"#ddaaff";
	tetris_piece[3]["img"] = tetris_piece3_img;//"blue.png";

	//piece 4:
	tetris_piece[4] = new Array();
	tetris_piece[4]["form"] = "44" +
						"40" +
						"40";
	tetris_piece[4]["width"] = 2;
	tetris_piece[4]["height"] = 3;
	tetris_piece[4]["color"] = tetris_piece4_color;//"#ffaadd";
	tetris_piece[4]["img"] = tetris_piece4_img;//"purple.png";

	//piece 5:
	tetris_piece[5] = new Array();
	tetris_piece[5]["form"] = "055" +
						"550";
	tetris_piece[5]["width"] = 3;
	tetris_piece[5]["height"] = 2;
	tetris_piece[5]["color"] = tetris_piece5_color;//"#ffddff";
	tetris_piece[5]["img"] = tetris_piece5_img;//"lightblue.png";

	//piece 6:
	tetris_piece[6] = new Array();
	tetris_piece[6]["form"] = "660" +
						"066";
	tetris_piece[6]["width"] = 3;
	tetris_piece[6]["height"] = 2;
	tetris_piece[6]["color"] = tetris_piece6_color;//"#aaddff";
	tetris_piece[6]["img"] = tetris_piece6_img;//"green.png";

	//piece 7:
	tetris_piece[7] = new Array();
	tetris_piece[7]["form"] = "070" +
						"777";
	tetris_piece[7]["width"] = 3;
	tetris_piece[7]["height"] = 2;
	tetris_piece[7]["color"] = tetris_piece7_color;//"#ffddaa";
	tetris_piece[7]["img"] = tetris_piece7_img;//"yellow.png";

	//Se guarda el number de pieces:
	tetris_number_pieces = tetris_piece.length - 1;

}
                
                
//Funcion que inicia el game:
function tetris_initialize_game()
{

	//Variable que contiene el ancho de cada celda (tile o panel):
	tetris_panel_width= parseInt(20*tetris_scale) ;
	//Varialbe que contiene el alto de cada celda (tile o panel):
	tetris_panel_height = parseInt(20*tetris_scale);

	//speed de caida de las pieces (entre menor, mas rapido):
	tetris_speed_initial = parseInt(tetris_initial_game_speed*tetris_scale); //speed initial.
	tetris_speed = tetris_speed_initial; //speed que ira incrementandose (al decrementar la variable).

	//Pizels de displacement en la caida de las pieces:
	displacement_initial = tetris_panel_height * 1; //displacement initial.
	tetris_displacement = displacement_initial; //displacement que ira incrementandose.

	// Set up the keyboard handler
	if (tetris_keyboard)
	{
		document.onkeydown= tetris_press_key;//(event, 'onkeypress');
		document.onKeyPress=tetris_press_key;//(event, 'onkeydown');
	}
	
	//alert((50*tetris_scale)+"px;");
	tetris_width=parseInt(tetris_number_columns*tetris_panel_width);//;//-1)*tetris_number_lines;
	tetris_height=parseInt(tetris_number_lines*tetris_panel_width);//-1)*tetris_number_lines;
	//document.getElementById("piece_following").style.width=tetris_width+"px";//+"px;";
	document.getElementById("piece_following").style.height=parseInt(40+tetris_panel_height*5)+"px";//+"px;";
	document.getElementById("piece_following").innerHTML="Next Piece:";
	document.getElementById("tetris_zone_game").style.height=tetris_height+"px";//parseInt(theheight*tetris_scale);//px;
	document.getElementById("tetris_zone_game").style.width=tetris_width+"px";//px;
	if (tetris_mouse)
	{
		document.getElementById("tetris_map").onmousedown=tetris_click	;				
		document.getElementById("tetris_map").onmouseup=tetris_mouseup;
		document.getElementById("tetris_map").ondblclick=tetris_dblclick	;
        document.getElementById("tetris_map").onmousemove=tetris_mousemove;		
	}	
	document.getElementById("tetris_map").style.height=tetris_height+"px";//px;
	document.getElementById("tetris_map").style.width=tetris_width+"px";//px;	
    if (!isExplorer)
		document.getElementById("tetris_map").style.position='absolute';
		
	document.getElementById("tetris_message").style.top=parseInt(tetris_height/2)+"px";
	document.getElementById("tetris_message").style.width=tetris_width+"px";
	//document.getElementById("tetris_message").style.left=parseInt(11*tetris_scale)+"px";
	tetris_show_message(tetris_start_message,true);
	
	document.getElementById("tetris_state").style.width=tetris_width+"px";//parseInt(244*tetris_scale)+"px";
	document.getElementById("tetris_state").innerHTML="";
	
	//alert(parseInt(thewidth*tetris_scale+2));
	document.getElementById("following_table").style.width=(tetris_width+2)+"px";//parseInt(thewidth*tetris_scale+2)+"px";
	
	if (tetris_background)
	{
	  document.getElementById('tetris_background_image').src=tetris_background;
	  document.getElementById('tetris_background_image').style.width=tetris_width+"px";
	  document.getElementById('tetris_background_image').style.height=tetris_height+"px";
	  document.getElementById('tetris_background_image').style.opacity=tetris_background_transparency;
	  document.getElementById('tetris_background_image').style.MozOpacity=tetris_background_transparency;
	  document.getElementById('tetris_background_image').style.filter='alpha(opacity='+parseInt(100*tetris_background_transparency)+')';//.alpha.opacity=parseInt(100*pong_background_transparency);
	}	
	//Se setea que aun no se ha acabado el game:
	tetris_game_over = false;

	//Desbloquea el prevent game over:
	prevent_tetris_game_over = false;

	//Se crean las pieces:
	tetris_create_pieces();
	
	//Se setea la speed a la initial:
	tetris_speed = tetris_speed_initial;
	//Se setea el displacement al initial:
	tetris_displacement = displacement_initial;
	
	//Se deifne el contador de leveles que incrementa el displacement, a 0:
	contador_leveles_displacement = 0;
	
	//Se definen las lineas del level actual a 0;
	lineas_level_actual = 0;
	
	//Se define el marcador de puntuacio a 0:
	puntuacion = 0;
	
	//Se define el level a 1:
	tetris_level = 1;

	//Se define el number de piece actual a 0 (ninguno):
	var tetris_number_piece = 0;
	//Se define el number de piece following a 0 (ninguno):
	var tetris_number_piece_following = 0;

	//Vaciar mapa (recorre la matrix, cambiando todo por 0):
	for (x=0; x<map_matrix.length; x++) {
	  map_matrix[x] = "0";
	}
	


}

function tetris_start_game()
{
	//Se recoge el mapa en una matrix, para calcular las diferencias con este y el posterior:
	map_matrix_previous = guardar_map_previous;
	
	//Se muestra el mapa:
	tetris_show_map(map_matrix, map_matrix_previous);

	//Se actualiza el marcador:
	update_marcador();
	
	//Se muestra el message de "Comienza el game":
	tetris_show_message(tetris_game_begins_message);//"The game begins");
	
	//Sacamos una piece:
	extract_piece();
}

//Funcion que actualiza la matrix del mapa:
function tetris_update_map(tetris_number_piece)
{
	//Si se ha enviado como piece el cero, es que no hay pieces:
	if (tetris_number_piece == 0)
	 {
		//Recorre la matrix, cambiando todo lo que no sea 0 ni X por 0:
		for (x=0; x<map_matrix.length; x++)
		 {
			//Si no es 0 ni X, lo cambia a 0:
			if (map_matrix[x] != "0" && !is_x(map_matrix[x])) {
			  map_matrix[x] = "0";
			}
		 }
	 }

	//Pero si se ha enviado otro number, mayor que cero:
	else if (tetris_number_piece > 0)
	 {
		//Se borra la piece del mapa:
		tetris_update_map(0);
		
		//Se calcula en que position de la matrix comienza la piece:
		matrix_position_x = tetris_number_columns - (parseInt(document.getElementById("tetris_piece").style.left) / tetris_panel_width);
		matrix_position_y = parseInt(document.getElementById("tetris_piece").style.top) / tetris_panel_height + 1;
		//Esta es la position initial (la clave de la matrix) donde comienza la piece:
		matrix_position_initial = (tetris_number_columns * matrix_position_y) - matrix_position_x;
		//Se actualiza la matrix pintando la piece en ella, segun la position:
//                        for (x=0; x<map_matrix.length; x++)
		for (x=matrix_position_initial; x<matrix_position_initial+tetris_piece[tetris_number_piece]["form"].length; x++)
		 {
			//Si estamos en el indice donde comienza la piece:
			if (x == matrix_position_initial)
			 {
				//El contador de columns:
				contador_columns = 0;
				//La variable que se suma para saltar una fila:
				saltar_fila = 0;
				for (y=0; y<tetris_piece[tetris_number_piece]["form"].length; y++)
				 {
					//Se toma como position de la matrix la position initial y se le suma la variable que hace saltar lines:
					position_matrix_actual = x + saltar_fila;
					//Si la position actual de la piece no es un cero, se graba en la matrix:
					if (tetris_piece[tetris_number_piece]["form"].substring(y, y+1) != "0") {map_matrix[position_matrix_actual] = tetris_piece[tetris_number_piece]["form"].substring(y, y+1); } //Se pinta la piece.
					//Se incrementa el contador de columns:
					contador_columns++;
					//Se incrementa la variable para saltar lines:
					saltar_fila++;
					//Si el contador de columns es mayor al ancho de la piece, se salta una fila:
					if (contador_columns >= tetris_piece[tetris_number_piece]["width"]) { contador_columns = 0; saltar_fila += tetris_number_columns - tetris_piece[tetris_number_piece]["width"]; }
				 }
			 }
		 }
	 }
}                

//Funcion que muestra el mapa en modo debug:
function tetris_show_map(map_matrix, map_matrix_previous)
 {

	//Si se ha enviado la misma matrix actual que la previous, sale de la funcion (no hay nada que update):
	if (map_matrix == map_matrix_previous) { return; }

	//Se setea el contador de columns a cero:
	var columns_contador = 0;
	//Se setea el contador de lines a cero:
	var lines_contador = 0;

	//Variable que guardara el color a utilizar en cada celda (tile o panel):
	var color_panel;

	//Se borra el mapa:
//                    document.getElementById("mapa").innerHTML = "";
//                    if (tetris_show_map_debug) { document.getElementById("map_debug").innerHTML = ""; } //Si esta en modo debug, tambien se borra el mapa debug.
	//Se crean las variables que guardaran la informacion del mapa:
	var map_bucle_temp = "";
	var map_debug_bucle_temp = "";

	//Se realiza un bucle para show el contenido de la matrix en el espacio de debug:
	 for (x=0; x<map_matrix.length; x++)
	  {
		 //Se calcula que color utilizar, segun el caracter de celda (tile o panel):
		 if (is_x(map_matrix[x])) {
		   color_panel = "#555555";
		   if (map_matrix[x].length>=2)
		   {
			  piecepos=map_matrix[x].substring(1);
			  img_panel=tetris_piece[piecepos]["img"];
		   }
		   else
			img_panel=null;
		 } //Color gris oscuro (caracter X, pieces ya colocadas).
		 else if (map_matrix[x] != 0) {

		   color_panel = tetris_piece[map_matrix[x]]["color"];
		   img_panel = tetris_piece[map_matrix[x]]["img"];
		 } //Color de la piece segun su number.
		
		 //Calcular la position de la celda (tile o panel):
		 panel_x = columns_contador * tetris_panel_width; //position horizontal.
		 panel_y = lines_contador * tetris_panel_height; //position vertical.

		 //Se muestra la imagen en la celda, siempre que no este vacia (0) y que haya habido un cambio desde la previous:
		 if (map_matrix[x] != 0 && map_matrix[x] != map_matrix_previous[x]) {
		   if (img_panel)
				map_bucle_temp += '<div style="top:'+panel_y+'px; left:'+panel_x+'px; width:'+tetris_panel_width+'px; height:'+tetris_panel_height+'px; position:absolute; padding:0px;  "><img id="P'+parseInt(Math.random()*9999)+'" width='+tetris_panel_width+' height='+tetris_panel_height+' src="'+img_panel+'"/></div>';
		   else
				map_bucle_temp += '<div id="P'+parseInt(Math.random()*9999)+'" style="background:'+color_panel+'; top:'+panel_y+'px; left:'+panel_x+'px; width:'+tetris_panel_width+'px; height:'+tetris_panel_height+'px; position:absolute; padding:0px;"></div>';
				
		 }

		 //Si esta activado el mapa debug, se escribe en el:
		 //if (tetris_show_map_debug) 
			//map_debug_bucle_temp += map_matrix[x];

		 //Se incrementa el contador de columns:
		 columns_contador++;

		 //Si se alcanza el number maximo de columns, se baja una fila y se setea otra vez el contador a cero y se incrementa el contador de lines (si esta el mapa en modo debug, se baja una linea en este):
		 if (columns_contador == tetris_number_columns) {
		   columns_contador = 0;
		   lines_contador++;
		   //if (tetris_show_map_debug) {
			//  map_debug_bucle_temp += "<br>";
		   //}
		 }
	  }
	 
	 //Se vuelcan las variables en el mapa:
	 document.getElementById("tetris_map").innerHTML = map_bucle_temp;
	 //if (tetris_show_map_debug) {
	//	document.getElementById("map_debug").innerHTML = map_debug_bucle_temp;
	 //} //Si esta en modo debug, tambien se vuelca el mapa en modo debug.
 }

//Funcion que saca una piece al escenario:
function extract_piece()
 {
	//Si ya ha habido game over, se sale de la funcion:
	if (prevent_tetris_game_over) { return; }
	
	//Si aun no seh a escogido ninguna piece, se escoge una aleatoriamente:
	if (tetris_number_piece == 0) {
	  tetris_number_piece = elegir_piece();
	}
	//Si antes ya se habia escogido alguna, se setea la actual como la following:
	else {
	  tetris_number_piece = tetris_number_piece_following;
	}
	//Ponemos el number de la piece following, escogido aleatoriamente, en una variable:
	tetris_number_piece_following = elegir_piece();
	
	//Se muestra la piece following:
	show_piece_following(tetris_number_piece_following);

	//Setear conforme todavia no se ha elevado verticalmente la piece al ser rotada:
	al_rotar_se_ha_elevado = false;

	//Borrar esto:
	//tetris_number_piece = 1;

	//Devolver las pieces a su state initial:
	tetris_create_pieces();

	//Se recoge el mapa en una matrix, para calcular las diferencias con este y el posterior:
	map_matrix_previous = guardar_map_previous;

	//Calcular ancho y alto de la piece, segun el number enviado:
	piece_width = tetris_piece[tetris_number_piece]["width"];
	piece_height = tetris_piece[tetris_number_piece]["height"];
	
	//Se situa horizontalmente en el centro:
	//document.getElementById("tetris_piece").style.left = parseInt( (tetris_number_columns * tetris_panel_width) / 2 - piece_width * tetris_panel_width) + "px";
	document.getElementById("tetris_piece").style.left = "0px";
	//Se situa verticalmente arriba:
	document.getElementById("tetris_piece").style.top = "0px";

	mover_piece(0, 0);

	//Se actualiza el mapa:
	//tetris_update_map(tetris_number_piece);tetris_show_map_debug(map_matrix);
	
	//Se muestra el mapa:
	tetris_show_map(map_matrix, map_matrix_previous);


	//Elimina el movimiento de la piece cayendo, por si aun existia:
	clearInterval(movimiento_piece);

	//Crea el movimiento de la piece cayendo:
	movimiento_piece = setInterval("map_matrix_previous = guardar_map_previous; mover_piece('mantener', parseInt(document.getElementById('tetris_piece').style.top) + tetris_displacement); tetris_show_map(map_matrix, map_matrix_previous);", tetris_speed);
 }

//Funcion que elige una piece aleatoriamente:
function elegir_piece()
 {
	//Variable que escoge un number aleatorio entre 1 y 8:
	var number_aleatorio = parseInt(Math.random() * tetris_number_pieces) + 1;
	
	//Retorna el number escogido de la piece:
	return number_aleatorio;
 }

//Funcion que mueve la piece segun las coordenadas enviadas:
function mover_piece(position_x, position_y)
 {
	//Si ya ha habido game over, se sale de la funcion:
	if (prevent_tetris_game_over) { return; }
	
	//Si se ha enviado mantener position horizontal, no mover la piece (conservar la X de esta):
	if (position_x == "mantener") {
	  position_x = parseInt(document.getElementById("tetris_piece").style.left);
	}
	
	//Variable para saber si la piece ha tocado fondo:
	var ha_tocado_fondo = false;
	//Si la piece esta en el limite de abajo, situa la piece lo maximo posible hacia abajo y se setea la variable ha_tocado_fondo a true:
	if (position_y > tetris_panel_height * tetris_number_lines - tetris_piece[tetris_number_piece]["height"] * tetris_panel_height) { position_y = tetris_panel_height * tetris_number_lines - tetris_piece[tetris_number_piece]["height"] * tetris_panel_height; ha_tocado_fondo = true; }
	//Si la piece esta en el limite izquierdo, situa la piece lo maximo posible hacia la left:
	if (position_x <= 0) { position_x = 0; }
	//Si la piece esta en el limite derecho, situa la piece lo maximo posible hacia la right:
	if (position_x + tetris_panel_width * tetris_piece[tetris_number_piece]["width"] > tetris_panel_width * tetris_number_columns) { position_x = tetris_panel_width * tetris_number_columns - tetris_piece[tetris_number_piece]["width"] * tetris_panel_width; }
	
	//Variables que impiden el movimiento horizontal si a la left o a la right de la piece hay otra ya colocada:
	prevent_movimiento_derecho = false;
	prevent_movimiento_izquierdo = false;

	//Realizar un bucle en la matrix:
	for (x=0; x<map_matrix.length; x++)
	 {
		//Si la position actual de la matrix contiene un caracter que no es 0 ni X, contiene una piece:
		if (map_matrix[x] != "0" && !is_x(map_matrix[x]))
		{
			
			//Si existe un caracter a la right del actual (no excede el tamao de la matrix):
			if (x + 1 <= map_matrix.length)
			 {
				//Si el caracter que hay a la right es una X, prevent movimiento horizontal:
				if (is_x(map_matrix[x+1])) { prevent_movimiento_derecho = true; } //Se impide movimiento horizontal hacia la right.
			 }
			
			//Si existe un caracter a la left del actual (no es menor a 0):
			if (x - 1 >= 0)
			 {
				//Si el caracter que hay a la left es una X, prevent movimiento horizontal:
				if (is_x(map_matrix[x-1] )) { prevent_movimiento_izquierdo = true; } //Se impide movimiento horizontal hacia la left.
			 }
		 }
	 }
	
	//Si la position horizontal es hacia la left y no esta impedida o es a la right y tampoco esta impedida, mueve la piece horizontalmente:
	position_x_actual = parseInt(document.getElementById("tetris_piece").style.left);
	if (position_x_actual > position_x && !prevent_movimiento_izquierdo || position_x_actual < position_x && !prevent_movimiento_derecho)
	 {
		document.getElementById("tetris_piece").style.left = position_x + "px"; //Se situa la piece en la position horizontal dada.
	 }
	
	//Se situa la piece en la position vertical dada:                    
	document.getElementById("tetris_piece").style.top = position_y + "px";
	
	//Se actualiza el mapa con la nueva position de la piece:
	tetris_update_map(tetris_number_piece);

	//Calcular colision:
	var ha_colisionado = calcular_colision();

	//Si la position vertical de la piece la situa abajo del todo, se convierte todo el mapa que no sea 0 a X:
	if (ha_tocado_fondo || ha_colisionado)
	 {
		//Elimina el movimiento de la piece cayendo, por si existia previousmente:
		//clearInterval(movimiento_piece);

		//Da 1 punto:
		puntuacion += 1;

		//Se setea todo lo que haya en el mapa como X (ya colocado):
		for (x=0; x<map_matrix.length; x++) {
		  if (map_matrix[x] != "0") {
			//if (map_matrix[x]>0)
			if (map_matrix[x].length>=1&&map_matrix[x].substring(0,1)!="X")
			{
				map_matrix[x] = "X"+map_matrix[x];
				tetris_dragging=null;
			}
			//else
			//	map_matrix[x] = "X";
		  }
		}

		//Se hace bajar la piece un panel, para que quede bien al pause el game:
		document.getElementById("tetris_piece").style.top = parseInt(document.getElementById("tetris_piece").style.top) + tetris_panel_height + "px";
		tetris_update_map();
		tetris_show_map(map_matrix, map_matrix_previous);
		
		//Calculamos si se ha llegado arriba del todo y se acaba el game:
		hay_tetris_game_over = calcular_tetris_game_over();

		//Se saca una piece:
		if (!hay_tetris_game_over) { extract_piece(); }
	 }
	
	//Calcular si se ha hecho linea:
	calcular_linea();
	
	//Se muestra el mapa:
//                    tetris_show_map(map_matrix);
//                    tetris_show_map(map_matrix, map_matrix_previous);
	
 }

//Funcion que calcula si una piece ha chocado con otra (poniendose encima):
function calcular_colision()
 {
	//Variable que calcula si ha colisionado o no:
	var ha_colisionado = false;
	
	//Realizar bucle en la matrix, buscar caracteres que no sean 0 ni X y calcular si justo debajo tienen una X:
	for (x=0; x<map_matrix.length; x++)
	 {
		//Si la position actual de la matrix contiene un caracter que no es 0 ni X, contiene una piece:
		if (map_matrix[x] != "0" && !is_x(map_matrix[x]))
		 {
			
			//Si existe un caracter debajo del actual (no excede el tamao de la matrix):
			if (x + tetris_number_columns <= map_matrix.length)
			{
				//Si el caracter que hay debajo es una X, ha colisionado:
				if (is_x(map_matrix[x+tetris_number_columns])) { ha_colisionado = true; break; } //Ha habido colision y sale del bucle.
			}
		 }
	 }

	//Si ha colisionado:
	if (ha_colisionado)
	 {
		//Retorna true:
		return true;
	 }
	//...y si no:
	else { return false; } //Retorna false;
 }

//Funcion que calcula si ha habido linea:
function calcular_linea()
 {
	//Calcular si ha habido linea y calcular cuantas:
	var columns_contador = 0;
	if (!number_de_lineas) { var number_de_lineas = 0; }
	var ha_habido_linea = false;
	var hay_linea = true;
	for (var x=0; x<map_matrix.length; x++)
	 {
		columns_contador++;

		if (!is_x(map_matrix[x] )) {
		  hay_linea = false;
		}

		if (columns_contador == tetris_number_columns)
		 {
			if (hay_linea)
			 {
				//Cambiar las X de la linea por 0:
				for (var y=x-tetris_number_columns+1; y<=x; y++)
				 {
					map_matrix[y] = "0";
				 }
				
				//Bajar lineas:
				se_ha_bajado_linea = hacer_caer_cuadros();
				
				//Volver a llamar a la funcion recursivamente si se ha bajado alguna linea, para ver si al bajar las pieces colocadas ha habido mas lineas:
//                                if (se_ha_bajado_linea) { calcular_linea(); }
				//calcular_linea();
				

				//Incrementar el contador de lineas:
				number_de_lineas++;

				ha_habido_linea = true;


				  
			 }
			columns_contador = 0;
			hay_linea = true;
		 }

		//tetris_update_map(tetris_number_piece);

		
	 }
	
   
	//Si ha habido linea, dar puntos segun cuantas lineas ha haya habido:
	dar_puntos(number_de_lineas);
	
 }

//Funcion que hace caer los cuadros (X) cuando debajo no tienen nada (0):
function hacer_caer_cuadros(position_final)
 {

	 //Todavia no se ha bajado ninguna linea:
	 se_ha_bajado_linea = false;
	
	//Calcula si la linea esta en el aire o no:
	var esta_en_el_aire = true;

	 //Bucle que va de arriba a abajo, haciendo caer las pieces:
//                     for (z=map_matrix.length-tetris_number_columns; z>=tetris_number_columns+1; z-=tetris_number_columns)
	 for (z=map_matrix.length-tetris_number_columns; z>=tetris_number_columns; z-=tetris_number_columns)
	 {
		//Calcula si la linea esta en el aire o no:
		esta_en_el_aire = true;
		
		//Comprueba que la linea este en el aire:
		for (k=z; k<=z+tetris_number_columns-1; k++) {
		  if (k > map_matrix.length || map_matrix[k] != "0" || z > tetris_number_columns && !is_x(map_matrix[k-tetris_number_columns]) && map_matrix[k-tetris_number_columns] != "0") {
			esta_en_el_aire = false;
		  }
		}
		
		//Si esta en el aire, se baja la linea:
		if (esta_en_el_aire)
		 {
		   for (k=z; k<=z+tetris_number_columns-1; k++)
			 {
				  //Se replica la piece en el cuadro de abajo:
				  map_matrix[k] = map_matrix[k-tetris_number_columns];
				  //Se borra la piece en el cuadro actual:
				  map_matrix[k-tetris_number_columns] = "0";
				  //Setear conforme se ha bajado una linea:
				  se_ha_bajado_linea = true;
				  
			 }
			//Se setea como que ya no estan en el aire:
			esta_en_el_aire = false; 
		 }
	   
	  }

	if (se_ha_bajado_linea) { return true; }
	else { return false; }
 }

//Funcion que rota la piece:
function rotar_piece(direccion)
 {
	//Se inviert el ancho y el alto de la piece:
	var width_original = tetris_piece[tetris_number_piece]["width"]; //El width previous.
	var height_original = tetris_piece[tetris_number_piece]["height"]; //El height previous.
	tetris_piece[tetris_number_piece]["width"] = height_original; //El nuevo width es el height.
	tetris_piece[tetris_number_piece]["height"] = width_original; //El number height es el width previous.
	
	//Se setea la matrix donde se guardara la nueva piece:
	var nueva_piece_matrix = new Array(); //Se declara la matrix.
	
	//Variables que serviran para realizar los bucles:
	var contador1 = 0;
	var contador2 = height_original;
	var contador3 = width_original;
   
	//Si se ha de rotar la piece a la right:
	if (direccion == "right")
	 {
		//Se realiza un bucle por la piece actual, y se guarda rotada a la right en la nueva piece:
		for (x=0; x<tetris_piece[tetris_number_piece]["form"].length; x++)
		 {
			//Formula que yo mismo descubri, despues de mucho pensar x):
			var formula = (contador1 * height_original) + (contador2  - 1);
			nueva_piece_matrix[formula] = tetris_piece[tetris_number_piece]["form"].substring(x,x+1);
			contador1++;
			contador3--;
			if (contador3 == 0) { contador3 = width_original; contador1 = 0; contador2--; }
		 }
	 }
   
	//...O si se ha de rotar la piece hacia la left (o tres veces hacia la right):
	else if (direccion == "left")
	 {
		//Se realiza un bucle por la piece actual, y se guarda rotada a la right en la nueva piece:
		for (x=tetris_piece[tetris_number_piece]["form"].length; x>0; x--)
		 {
			//Formula que yo mismo descubri, despues de mucho pensar x):
			var formula = (contador1 * height_original) + (contador2  - 1);
			nueva_piece_matrix[formula] = tetris_piece[tetris_number_piece]["form"].substring(x-1,x);
			contador1++;
			contador3--;
			if (contador3 == 0) { contador3 = width_original; contador1 = 0; contador2--; }
		 }
	 }

	//position vertical de la piece                     
	position_y = parseInt(document.getElementById("tetris_piece").style.top);
	
	//Calcular si al rotarse la piece va a estar encima de alguna X, entonces moverla a un lugar cercano (hasta en position horizontal - ancho piece, position horizontal + ancho piece, position vertical + alto piece o en position vertical - alto piece) con 0.
	//Calcular si la piece va a chocar al rotarse con alguna piece inferior o lateral:
	//* Si hay pieces debajo, elevar la piece un cuadro.
	//* Si hay pieces al lado, mover la piece al lado contrario.
	//* Si la nueva position calculada no es posible (hay X en lo que va a ocupar), no rotar la piece y salir de la funcion.
	
	//Si la piece va a estar demasiado cerca del borde inferior (abajo) o de alguna piece inferior, se sube un poco hacia arriba:
	if (position_y + tetris_piece[tetris_number_piece]["height"] * tetris_panel_height >= tetris_number_lines * tetris_panel_height) {
	  position_y -= parseInt(tetris_piece[tetris_number_piece]["height"] / 2 + 1) * tetris_panel_height; al_rotar_se_ha_elevado = true;
	}
	//...y si no, y ya ha sido elevada previousmente al rotarse, se vuelve a bajar:
	else if (al_rotar_se_ha_elevado) {
	  position_y += parseInt(tetris_piece[tetris_number_piece]["width"] / 2 + 1) * tetris_panel_height;
	}

	//Variable donde se guardara la forma de la nueva piece rotada:
	var nueva_piece = "";
	//Se realiza un bucle para introducir lo que hay en la matrix en una variable de texto plano:
	for (x = 0; x<nueva_piece_matrix.length; x++)
	 {
		nueva_piece += nueva_piece_matrix[x];
	 }
	//Se setea la forma de la piece actual a la nueva piece que hemos rotado:
	tetris_piece[tetris_number_piece]["form"] = nueva_piece;
	
	//Retorna la position vertical de la piece:
	return position_y;
 }

//Funcion que da puntos, segun un number de lineas enviado:
function dar_puntos (number_lineas)
 {
	//Variable donde se guardara el message a show, si es necesario:
	var message = "";
	
	//Dar puntos, segun las lineas:
	if (number_lineas == 4) { puntuacion += 400; message = "Tetris"; } //Se han hecho 4 lineas (tetris).
	else if (number_lineas == 3) { puntuacion += 300; message = "Triple"; } //Se han hecho 3 lineas (triple).
	else if (number_lineas == 2) { puntuacion += 200; message = "Double"; } //Se han hecho 2 lineas (doble).
	else if (number_lineas == 1) { puntuacion += 100; message = "Single"; } //Se ha hecho 1 linea (simple).
						
	//show en medio de la pantalla cuantas lineas se han hecho, siempre que se haya hecho alguna, y suma al contador de lineas:
	if (message != "") {
	  tetris_show_message(message);
	  lineas_level_actual++;
	}
	
	//Si elas lineas del level actual alcanza o supera las necesarias para pasar de level, se llama a la funcion de pasar de level:
	if (lineas_level_actual >= lineas_necesarias)
	 {
		pasar_level();
	 }
	
	//update marcador:
	update_marcador();
 }
 
//Funcion que pasa de level cada X lineas:
function pasar_level()
 {
	//Si esta habiendo game over, salir de la funcion:
	if (prevent_tetris_game_over) { return; }
	
	//Calcular si el number de lineas realizadas en el level actual es igual o supera a lineas_necesarias, y entonces cambia de level:
	if (lineas_level_actual >= lineas_necesarias)
	 {
		//Se define el contador de lineas de cada level a cero:
		lineas_level_actual = 0;

		//Se incrementa el contador de leveles, que al llegar a 10 incrementa el displacement de la piece:
		contador_leveles_displacement++;

		//Se suma un level:
		tetris_level++;
		
		//Se sube la speed initial (ahora la piece tardara 50 milisegundos menos en caer hacia abajo en cada movimiento):
		if (tetris_speed_initial - tetris_scale*tetris_speed_increase_per_level >= 0) {
		   tetris_speed -= tetris_scale*tetris_speed_increase_per_level;
		}
		
		//Si el contador de leveles llega a 10, se sube el displacement de la piece (ahora la piece se desplazara mas en cada caida):
		if (contador_leveles_displacement >= 10 && displacement_initial <= tetris_panel_height * tetris_number_lines) {
		   tetris_displacement += tetris_panel_height;
		   contador_leveles_displacement = 0;
		}
		
		//Se dan 1000 puntos:
		puntuacion += 1000;
	 }

	//show en pantalla que se ha pasado de level:
	tetris_show_message("Welcome to level "+tetris_level);
	
	//update marcador:
	update_marcador();
 }

//Funcion que actualiza el marcador:
function update_marcador()
 {
	//Actualiza el marcador (barra de state):
	document.getElementById("tetris_state").innerHTML = "&nbsp; Level: "+tetris_level+" | Score: "+puntuacion;
	
	/*if (tetris_game_over) {
	  document.getElementById("tetris_state").innerHTML += " | [Game Over]";
	}*/
 }

//Funcion que muestra la piece following:
function show_piece_following(tetris_number_piece_following)
 {
	//Variable que contendra la piece following painted (los div):
	var piece_painted = "";
	//position de la piece en el cuadro de "piece following":
	position_y = 40;//tetris_panel_height+15; //position vertical initial.
	position_x = tetris_panel_width; //position horizontal initial.
	
	//Contador de columns, para saber cuando bajar la celda:
	var contador_columns = 0;

	//Se realiza un bucle hasta cumplir el number de celdas que tenga la piece:
	for (x=0; x<tetris_piece[tetris_number_piece_following]["form"].length; x++)
	{
		//Se coge el color de la piece:
		color_piece = tetris_piece[tetris_number_piece_following]["color"];
		img_piece = tetris_piece[tetris_number_piece_following]["img"];
		//Si la celda actual no esta vacia (0), se pinta (se crea un div con las positiones correspondientes):
		if (tetris_piece[tetris_number_piece_following]["form"].substring(x,x+1) != "0") {
		  if (img_piece)
			piece_painted += '<div style=" left:'+position_x+'px; top:'+position_y+'px; width:'+tetris_panel_width+'; height:'+tetris_panel_height+'; ifont-size:1px; position:absolute; iz-index:5001;"><img width='+tetris_panel_width+' height='+tetris_panel_height+' src="'+img_piece+'"/></div>';
		  else
			piece_painted += '<div style="background:'+color_piece+'; left:'+position_x+'; top:'+position_y+'; width:'+tetris_panel_width+'; height:'+tetris_panel_height+'; font-size:1px; position:absolute; iz-index:5001;"></div>';
		}
		//Se incrementa la position horizontal:
		position_x += tetris_panel_width;
		//Se incrementa una columna:
		contador_columns++;
		//Si se ha llegado al fin de las columns, se baja una fila y se setea las columns a 0:
		if (contador_columns >= tetris_piece[tetris_number_piece_following]["width"]) {
		  contador_columns = 0;
		  position_y += tetris_panel_height; position_x = tetris_panel_width;
		}
	 }
	
	//Se muestra la ficha que hemos "pintado":
	document.getElementById("piece_following").innerHTML = "Next piece:"+piece_painted;
 }

//Funcion que muestra un message en medio de la pantalla, durante un tiempo:
function tetris_show_message(message,donthide)
 {
	//Se borra el Timeout previous por si ya existia de antes:
	clearTimeout(tetris_hide_message);
	//Se pone el teto en el recuadro:
	document.getElementById("tetris_message").innerHTML = message;
	//Se hace visible el recuadro:
	document.getElementById("tetris_message").style.visibility = "visible";
	//Se esconde el recuadro a los 1500 milisegundos (un segundo y medio):
	if (!donthide)
	  tetris_hide_message = setTimeout("document.getElementById('tetris_message').style.visibility = 'hidden';", 1500);
 }                

//Funcion que calcula si se ha llegado al tope de la pantalla, y si es asi da GameOver:
function calcular_tetris_game_over()
 {
	//Si ya se ha ejecutado game over, sale de la funcion:
	if (prevent_tetris_game_over) {
	  return;
	}
	
	//Variable que definira si se ha llegado arriba del todo o no:
	var se_ha_llegado_arriba = false;
	
	//Calcular si se ha llegado al fin del mapa, con un bucle:
	for (x=0; x<tetris_number_columns; x++)
	 {
		//Si arriba del mapa hay otra cosa que no es un 0, se ha llegado arriba:
		if (map_matrix[x] != "0") { se_ha_llegado_arriba = true; }
	 }
	
	//Si ha llegado arriba del todo, hace el game over y luego inicia otro game nuevo:
	if (se_ha_llegado_arriba)
	 {
		//Setea el game over:
		tetris_game_over = true;
	
		//update marcador:
		update_marcador();
	
		//Se muestra el message:
		tetris_show_message(tetris_gameover_message,true);
	
		//prevent Game Over:
		prevent_tetris_game_over = true;

		if (document.getElementById('tetris_winform')&&
		   (!tetris_bestscore||tetris_bestscore==-1||puntuacion>tetris_bestscore))
		{
			document.getElementById('tetris_win_message').value=tetris_gameover_message;
			document.getElementById('tetris_ticker').value=puntuacion;
			document.getElementById('tetris_winform').submit();
		}		
		
		//Se alerta:
		//alert("Game Over");
	
		//Se comienza el game en 2 segundos:
	   // setTimeout("tetris_initialize_game();", 2000);
	 
		return true;
	 }
	
	else { return false; } //No ha habido game over.
	
 }

//Funcion que recoge el mapa en la variable map_matrix_previous()
function guardar_map_previous()
 {
	var map_matrix_previous = new Array();
	for (x=0; x<map_matrix.length; x++)
	 {
		map_matrix_previous[x] = map_matrix[x];
	 }
	return map_matrix_previous;
 }

//Funcion que captura la key pulsada y realiza la funcion necesaria:
function tetris_press_key(e, evento_actual)
 {
	//Si esta en pausa el game, se sale de la funcion:
	if (!movimiento_piece) { 
	  return;
	}

	//Se recoge el mapa en una matrix, para calcular las diferencias con este y el posterior:
	map_matrix_previous = guardar_map_previous;

	//Si el primer evento esta vacio, se le introduce como valor el evento actual (el que ha llamado a esta funcion):
	if (primer_evento == "") {
	  primer_evento = evento_actual;
	}
	//Si el primer evento no es igual al evento actual (el que ha llamado a esta funcion), se vacia el primer evento (para que a la proxima llamada entre en la funcion) y se sale de la funcion:
	if (primer_evento != evento_actual) {
	  primer_evento = ""; return;
	}

	//Capturamos la tacla pulsada, segun navegador:
	if (isExplorer)/*e.keyCode*/ {
	  e=window.event ;
	  var unicode = e.keyCode;
	}
	//else if (event.keyCode) { var unicode = event.keyCode; }
	else if (window.Event && e.which) {
	  var unicode = e.which;
	}
	else {
	  var unicode = 40;
	} //Si no existe, por defecto se utiliza la flecha hacia abajo.

	//Se obtiene la position actual de la piece:
	position_x = parseInt(document.getElementById("tetris_piece").style.left); //position horizontal.
	position_y = parseInt(document.getElementById("tetris_piece").style.top); //position vertical.

	//Si se pulsa la flecha hacia abajo, se suman 20 pixels verticales:
	if (unicode == tetris_downkey||unicode ==40) {
	  position_y += tetris_panel_height;//20*tetris_scale;
	}
	//...y si se pulsa la flecha hacia la right, se suman 20 pixels horizontales:
	else if (unicode == tetris_rightkey||unicode ==39) {
	  position_x += tetris_panel_width;//20*tetris_scale;
	}
	//...y si se pulsa la flecha hacia la left, se restan 20 pixels horizontales:
	else if (unicode == tetris_leftkey||unicode ==37) {
	  position_x -= tetris_panel_width;//20*tetris_scale;
	}
	//...y si se pulsa flecha arriba (38), control (17), intro (13) o . (190), se rota la piece hacia la right:
	else if (unicode== tetris_upkey || unicode == 38 || unicode == 17 || unicode == 13 || unicode == 190) {
	  position_y = rotar_piece("right");
	}
	//...y si se pulsa shift (16), espacio (32), 0 (96) o insert (45), se rota la piece hacia la left:
	else if (unicode == 16 || unicode == 32 || unicode == 96 || unicode == 45) {
	  position_y = rotar_piece("left");
	}

	
	//Se mueve la piece:
	mover_piece(position_x, position_y);

	//Se muestra el mapa:
	tetris_show_map(map_matrix, map_matrix_previous);
 }


//Funcion que pausa o reanuda el game:
function pause_reanudar_game()
 {
	//Si la piece no esta moviendose, se reanuda:
	if (!movimiento_piece) {
	  movimiento_piece = setInterval("map_matrix_previous = guardar_map_previous; mover_piece('mantener', parseInt(document.getElementById('tetris_piece').style.top) + tetris_displacement); tetris_show_map(map_matrix, map_matrix_previous);", tetris_speed);
	  tetris_show_message("Game resumed");
	  document.getElementById("tetris_pause").innerHTML = "&nbsp;&nbsp;&nbsp;[ Pause ]";
	  document.getElementById("tetris_pause").title = "Click here to pause game";
	}
	//...pero si ya esta moviendose, se pausa:
	else {
	  clearInterval(movimiento_piece);
	  movimiento_piece = false;
	  document.getElementById("tetris_message").innerHTML = "Game paused";
	  document.getElementById("tetris_message").style.visibility = "visible";
	  setTimeout('document.getElementById("tetris_message").innerHTML = "Game paused"; document.getElementById("tetris_message").style.visibility = "visible";', 1500);
	  document.getElementById("tetris_pause").innerHTML = "&nbsp;&nbsp;&nbsp;[ Resume ]";
	  document.getElementById("tetris_pause").title = "Click here to resume game";
	}
}


	function tetris_mousemove(e) {
		if (!isExplorer)
		{
		    id=e.target.id;
			mX=e.layerX;
			mY=e.layerY;
		}
		else
		{
			id=event.srcElement.id;
			mX=event.offsetX + document.body.scrollLeft;
			mY=event.offsetY + document.body.scrollTop;
		}
		if (id=='tetris_map')
		{
	        //document.getElementById("tetris_pause").innerHTML =new Date().getTime();		
	        position_y = parseInt(document.getElementById("tetris_piece").style.top); //position vertical.
			if (tetris_dragging)
			{
	            //alert(document.getElementById("tetris_zone_game").style.height);
			    //alert((tetris_dragging_y-tetris_dragging_start_y)+"  "+(document.getElementById("tetris_zone_game").style.height/2));
				if (!tetris_dragging_start_y)
					tetris_dragging_start_y=mY;
				if (mY-tetris_dragging_start_y>tetris_panel_height)
				        position_x = parseInt(document.getElementById("tetris_piece").style.left);			
					    position_y+=tetris_panel_height;

			}
			else
			{
			  position_x = tetris_panel_width* parseInt(mX / tetris_panel_width); 
			}


	        //Se obtiene la position actual de la piece:
	        //position_x = parseInt(document.getElementById("tetris_piece").style.left); //position horizontal.
	                    
	                    //Se mueve la piece:
	        mover_piece(position_x, position_y);
	                    //Se muestra el mapa:
	        tetris_show_map(map_matrix, map_matrix_previous);

		}
		return false;
	}	

	function tetris_click(e)
	{
        if(!e) var e=window.event;

		bLeftClick=false;
		bRightClick=false;
        if(e.which){

		      id=e.target.id;
              if (e.which==1)
			    bLeftClick=true;
			  else if  (e.which==3)
			    bRightClick=true;
        }

        else if(e.button){
			 id=e.srcElement.id;
              if (e.button==1)
			    bLeftClick=true;
			  else if  (e.button==2)
			    bRightClick=true;

        }		
	    if (bLeftClick)
		{
			tetris_dragging=true;//id;
			tetris_dragging_start_y=null;
		}
		else if (bRightClick)
		{
				position_y = rotar_piece("right");
				//position_y = rotar_piece("left");

				position_x = parseInt(document.getElementById("tetris_piece").style.left);			
				//Se mueve la piece:
				mover_piece(position_x, position_y);

				//Se muestra el mapa:
				tetris_show_map(map_matrix, map_matrix_previous);	
        }				
	}
		  
function tetris_dblclick(e){

	    tetris_dragging=false;
        var rightclick='';

        if(!e) var e=window.event;

		
        if(e.which){

		      id=e.target.id;
              if (e.which==1)
			    bLeftClick=true;
			  else if  (e.which==3)
			    bRightClick=true;
        }

        else if(e.button){
			  id=e.srcElement.id;
              if (e.button==1)
			    bLeftClick=true;
			  else if  (e.button==2)
			    bRightClick=true;


        }

		position_y = rotar_piece("left");

		position_x = parseInt(document.getElementById("tetris_piece").style.left);			
				//Se mueve la piece:
		mover_piece(position_x, position_y);

				//Se muestra el mapa:
		tetris_show_map(map_matrix, map_matrix_previous);



} 

function tetris_mouseup(e)
{
		tetris_dragging=false;

}

  

